#include <cstring>
#include <benchmark/benchmark.h>


int total = 0; // Used to stop compilers from optimising out the loops by creating a side effect of the processes


static void memory_allocate_deallocate(benchmark::State& state)
{
	for (auto _ : state)
	{
		int *ints = new int[5000];
		ints[1] = 27;
		total += ints[1];
		total += ints[0];
		delete ints;
	}
}


static void memory_memset(benchmark::State& state)
{
	int ints[50000];
	
	for (auto _ : state)
	{
		std::memset(ints, 0, sizeof(int) * 50000);
		ints[1] = 50;
		total += ints[1];
	}
}


// Register the function as a benchmark
BENCHMARK(memory_allocate_deallocate);
BENCHMARK(memory_memset);



int main (int argc, char ** argv)
{
    benchmark::Initialize (&argc, argv);
    benchmark::RunSpecifiedBenchmarks ();
	printf("Total = %d\n", total);
    return 0;
}
